@ECHO OFF
:: ===================================================
:: - Batch-Name: 3P-Color.BAT                        -
:: ===================================================
:: -         Batch by Uwe Morgener - 05.2003         -
:: -      fuer Crosspoint (XP2/OpenXP) und UKAW      -
:: ---------------------------------------------------
:: - Zweck: Farbeinstellungen von 3P-Batch an die    -
:: - ====== Farben von Crosspoint anpassen           -                                         
:: -        ACHTUNG: rekursiver Aufruf!!             -
:: ---------------------------------------------------
:: -      (Utilitie zum Paket: 3P-Batch v1.20)       -
:: ---------------------------------------------------

::Color0.bat
IF %1'==Konvert' GOTO Konvert
IF %1'==ANSICode' GOTO ANSICode
IF NOT %1'==' GOTO ParaErr
GOTO Start

:: ===================================================================

Farbtabelle
===========

XP-Code WBat-Farbe      Name der Farbe
-------+---------------+--------------
0       black           Schwarz
1       blue            Blau
2       green           Grn
3       cyan            Cyanblau
4       red             Rot
5       magenta         Karmesinrot
6       brown           Braun
7       white           Grau
8       +black          Dunkelgrau
9       +blue            hell-blau
a       +green           hell-grn
b       +cyan            hell-cyan
c       +red             hell-rot
d       +magenta         hell-lila
e       +brown          Gelb
f       +white          Weis

Vollstndiger Farbcode von XP: $00
                                 0 =Zeichenfarbe
                                0  =Hintergrundfarbe
                               $   =Steuerzeichen
:: ===================================================================
:: Fehlermeldung ausgeben
:NoVar
ECHO F E H L E R
ECHO ===========
ECHO Umgebungsvariable: %Var% nicht gesetzt...
GOTO ErrEnde

:NoFile
ECHO F E H L E R
ECHO ===========
ECHO Datei: %Datei% nicht gefunden...
GOTO ErrEnde

:NoESpace
ECHO F E H L E R
ECHO ===========
ECHO Zu wenig Umgebungsspeicher vorhanden...
GOTO ErrEnde

:ParaErr
ECHO F E H L E R
ECHO ===========
ECHO bergebener Parameter unbekannt...
GOTO ErrEnde

:ErrEnde
ECHO bernahme der XP-Farbeinstellungen daher 
ECHO nicht mglich.
ECHO.
Pause
GOTO Ende
:: ===================================================================

:Start
:: auf notwendige Umgebung prfen

:: gengend Umgebungsspeicher vorhanden?
%PPP%\3P ESpace 446
IF Errorlevel==1 GOTO NoESpace

SET Var=
IF %XP%'==' SET Var=XP
IF %PPP%'==' SET Var=PPP
IF NOT %Var%'==' GOTO NoVar
CD %PPP%

SET Datei=
IF NOT EXIST %XP%\XPoint.col SET Datei=XPoint.col
IF NOT EXIST %PPP%\3P.com SET Datei=3P.com
IF NOT EXIST %PPP%\Var.bat SET Datei=Var.bat
IF NOT EXIST %PPP%\WBat_ini.Lay SET Datei=WBat_ini.Lay
IF NOT %Datei%'==' GOTO NoFile

:: WBat_ini.Lay zerlegen
3P WBAT StdOut @WBat_ini.Lay:WBAT0 > WBat.0
3P WBAT StdOut @WBat_ini.Lay:WBAT1 > WBat.1
3P WBAT StdOut @WBat_ini.Lay:WBAT2 > WBat.2
3P WBAT StdOut @WBat_ini.Lay:WBAT3 > WBat.3
3P WBAT StdOut @WBat_ini.Lay:WBAT4 > WBat.4
3P WBAT StdOut @WBat_ini.Lay:WBAT5 > WBat.5
3P WBAT StdOut @WBat_ini.Lay:WBAT6 > WBat.6

:: wenn WBat.ini vorhanden, dann ...
IF NOT EXIST WBat.ini GOTO NoINI
:: ... [error]-Usereinstellungen aus dieser auslesen und ...
CALL VAR GET SndBeep, ErrBeep, MailEMP, ErrList FROM WBat.ini
:: ... WBat.5 mit den Usereinstellungen berschreiben
ECHO SndBeep=%SndBeep%>WBat.5
ECHO ErrBeep=%ErrBeep%>>WBat.5
ECHO MailEMP=%MailEMP%>>WBat.5
ECHO ErrList=%ErrList%>>WBat.5
:: Hilfsvariablen wieder lschen
FOR %%S IN (SndBeep ErrBeep MailEMP ErrList) DO SET %%S=

:NoINI
ECHO Farben werden aus Crosspoint ausgelesen 
ECHO und fr 3P-Batch aufbereitet.
ECHO.
ECHO Bitte warten...
:: ===================================================================
:: -=[ Allgemeine Farben ]=-
CALL VAR GET Bretter FROM %XP%\XPoint.col

:: Screen...: Default fr CLS und FILL
:: (XPoint.col: User/Bretter, Text)
ECHO %Bretter% | 3P LMOD SET Screen=[$1]>temp.bat
CALL temp.bat
DEL temp.bat

:: eingelesene Werte in Zeichen- und Hintergrundfarbe zerlegen,
:: konvertieren und in Umgebungsvariable ablegen
CALL 3P-Color.bat Konvert %Screen% Screen

:: zugehrigen ANSI-Code ermitteln fr...
:: ... Zeichenfarbe
CALL 3P-Color.bat ANSICode %Char%
SET Char_=%Col_%
SET CharAttr=%ColAttr%
:: ... Hintergrundfarbe
CALL 3P-Color.bat ANSICode %Back%
SET Back_=%Col_%
SET BackAttr=%ColAttr%
:: ... und die zugehrigen Helligkeitsattribute
IF %CharAttr%%BackAttr%'==00' SET Attr_=m
IF %CharAttr%%BackAttr%'==01' SET Attr_=5m
IF %CharAttr%%BackAttr%'==10' SET Attr_=1m
IF %CharAttr%%BackAttr%'==11' SET Attr_=1m
::
:: Ansi-Treiber geladen?
3P WBat Ansi?
:: Wurde, sowohl fr Vorder- als auch Hintergrund, eine Farbe mit dem Attribut
:: "hell" ermittelt, dann das Attribut der Hintergrundfarbe auf "normal" stellen.
:: ANSI-Treiber knnen nur Vorder- /oder/ Hintergrund in "hell" darstellen.
IF ERRORLEVEL==0 IF %CharAttr%%BackAttr%'==11' CALL VAR SET Back=STRING(2) %Back%
:: Farbe fr WBat.com erstellen
SET Screen=%Char% on %Back%

:: Farben einstellen
ECHO AnsiScreen=3%Char_%;4%Back_%;%Attr_%>screen.tmp
ECHO Screen=%Screen%>>screen.tmp

:: Hilfsvariablen lschen
FOR %%S IN (Back Char Bretter) DO SET %%S=
FOR %%S IN (Back_ Char_ Attr_ Col_ CharAttr BackAttr ColAttr) DO SET %%S=
FOR %%S IN (Screen) DO SET %%S=

:: ===================================================================
:: -=[ Farben fr die Menues ]=-
CALL VAR GET Menue1 FROM %XP%\XPoint.col

:: Button...: aktivierbare Menuepunkte
:: Divider..: Trennlinien im Menue ("", Code 196) (/Nur/ Vordergrund von Box)
:: (XPoint.col: Menue1, 1.Menebene, Text)
ECHO %Menue1% | 3P LMOD SET Button=[$1]>temp.bat
:: Hotkey...: Nummern der Menuepunkte (Hintergrundfarbe optional)
:: (XPoint.col: Menue1, 1.Menebene, Tasten)
ECHO %Menue1% | 3P LMOD SET Hotkey=[$2]>>temp.bat
:: BoxTitle.: Menue-Titel
:: Bar......: Auswahlbalken
:: (XPoint.col: Menue1, 1.Menebene, Balken)
ECHO %Menue1% | 3P LMOD SET BoxTitle=[$3]>>temp.bat
:: Box......: inaktive Menuepunkte
:: (XPoint.col: Menue1, 1.Menebene, deaktiviert)
ECHO %Menue1% | 3P LMOD SET Box=[$5]>>temp.bat
:: Shadow...: Schatten der Fenster/Menues (NONE: kein Schatten)
:: /immer/ Shadow=+black
CALL temp.bat
DEL temp.bat

:: eingelesene Werte in Zeichen- und Hintergrundfarbe zerlegen,
:: konvertieren und in Umgebungsvariable ablegen
CALL 3P-Color.bat Konvert %Box% Box
CALL 3P-Color.bat Konvert %Hotkey% Hotkey
SET Hotkey=%char%
CALL 3P-Color.bat Konvert %BoxTitle% BoxTitle
CALL 3P-Color.bat Konvert %Button% Button
SET Divider=%Char%

ECHO BoxTitle=%BoxTitle%>color.tmp
ECHO Bar=%BoxTitle%>>color.tmp
ECHO Button=%Button%>>color.tmp
ECHO Box=%Box%>>color.tmp
ECHO Hotkey=%Hotkey%>>color.tmp
ECHO Divider=%Divider%>>color.tmp
ECHO Shadow=+black>>color.tmp

:: Hilfsvariablen lschen
FOR %%S IN (Back Char Menue1) DO SET %%S=
FOR %%S IN (BoxTitle Bar Button Box Hotkey Divider Shadow) DO SET %%S=

:: ===================================================================
:: -=[ Farben fr die Fehlermeldungen ]=-
:: -=[ Farben fr die Hinweise ]=-
CALL VAR GET MBox FROM %XP%\XPoint.col

:: WBox.....: Text
:: (XPoint.col: Meldungs-Fenster, Text)
ECHO %MBox% | 3P LMOD SET WBox=[$1]>temp.bat
:: WBoxHi...: hervorgehobenen Text
:: (XPoint.col: Meldungs-Fenster, Prioritt hervorgehoben)
ECHO %MBox% | 3P LMOD SET WBoxHi=[$4]>>temp.bat
CALL temp.bat
DEL temp.bat

:: eingelesene Werte in Zeichen- und Hintergrundfarbe zerlegen,
:: konvertieren und in Umgebungsvariable ablegen
CALL 3P-Color.bat Konvert %WBox% WBox
SET WChar=%Char%
CALL 3P-Color.bat Konvert %WBoxHi% WBoxHi
:: WBoxTitle: Titel
:: WBar.....: OK-Button
:: WDivider.: Trennlinie ("", Code 196)
:: Shadow...: Schatten der Fenster/Menues (NONE: kein Schatten)

:: -=[ Farben fr die Fehlermeldungen ]=-
SET WBack=+red
ECHO WBoxTitle=%WChar% on %WBack%>mcolor.tmp
ECHO WBar=%WChar% on %WBack%>>mcolor.tmp
ECHO WBox=%WBox%>>mcolor.tmp
ECHO WBoxHi=%WBoxHi%>>mcolor.tmp
ECHO WDivider=%WBack%>>mcolor.tmp
ECHO WShadow=+black>>mcolor.tmp

:: -=[ Farben fr die Hinweise ]=-
SET WBack=cyan
ECHO WBoxTitle=%WChar% on %WBack%>hcolor.tmp
ECHO WBar=%WChar% on %WBack%>>hcolor.tmp
ECHO WBox=%WBox%>>hcolor.tmp
ECHO WBoxHi=%WBoxHi%>>hcolor.tmp
ECHO WDivider=%WBack%>>hcolor.tmp
ECHO WShadow=+black>>hcolor.tmp

:: Hilfsvariablen lschen
FOR %%S IN (Back Char MBox WBack WChar) DO SET %%S=
FOR %%S IN (WBoxTitle WBar WBox WBoxHi WDivider WShadow) DO SET %%S=

:: ===================================================================
:: WBat.ini aus den Einzelteilen zusammen kopieren
COPY /B WBat.0 + Screen.tmp + WBat.1 + Color.tmp + WBat.2 WBat.ini >NUL
COPY /B WBat.ini + mColor.tmp + WBat.3 + hColor.tmp + WBat.4 WBat.ini >NUL
COPY /B WBat.ini + WBat.5 + WBat.6 WBat.ini >NUL

:: Hilfsdateien lschen
FOR %%D IN (0 1 2 3 4 5 6) DO DEL WBat.%%D
DEL *.tmp

ECHO.
ECHO bernahme der Farben abgeschlossen...
ECHO.
GOTO Ende

:: ===================================================================
:Konvert
CALL VAR SET Back=STRING(2,1) %2
CALL VAR SET Char=STRING(3,1) %2

IF %Back%'==0' SET Back=black
IF %Back%'==1' SET Back=blue
IF %Back%'==2' SET Back=green
IF %Back%'==3' SET Back=cyan
IF %Back%'==4' SET Back=red
IF %Back%'==5' SET Back=magenta
IF %Back%'==6' SET Back=brown
IF %Back%'==7' SET Back=white
IF %Back%'==8' SET Back=+black
IF %Back%'==9' SET Back=+blue
IF %Back%'==a' SET Back=+green
IF %Back%'==b' SET Back=+cyan
IF %Back%'==c' SET Back=+red
IF %Back%'==d' SET Back=+magenta
IF %Back%'==e' SET Back=+brown
IF %Back%'==f' SET Back=+white

IF %Char%'==0' SET Char=black
IF %Char%'==1' SET Char=blue
IF %Char%'==2' SET Char=green
IF %Char%'==3' SET Char=cyan
IF %Char%'==4' SET Char=red
IF %Char%'==5' SET Char=magenta
IF %Char%'==6' SET Char=brown
IF %Char%'==7' SET Char=white
IF %Char%'==8' SET Char=+black
IF %Char%'==9' SET Char=+blue
IF %Char%'==a' SET Char=+green
IF %Char%'==b' SET Char=+cyan
IF %Char%'==c' SET Char=+red
IF %Char%'==d' SET Char=+magenta
IF %Char%'==e' SET Char=+brown
IF %Char%'==f' SET Char=+white

SET %3=%Char% on %Back%
GOTO Ende
:: ===================================================================
:ANSICode
rem set Col_=InvalidColor
IF %2'==black' SET Col_=0
IF %2'==black' SET ColAttr=0
IF %2'==blue' SET Col_=4
IF %2'==blue' SET ColAttr=0
IF %2'==green' SET Col_=2
IF %2'==green' SET ColAttr=0
IF %2'==cyan' SET Col_=6
IF %2'==cyan' SET ColAttr=0
IF %2'==red' SET Col_=1
IF %2'==red' SET ColAttr=0
IF %2'==magenta' SET Col_=5
IF %2'==magenta' SET ColAttr=0
IF %2'==brown' SET Col_=3
IF %2'==brown' SET ColAttr=0
IF %2'==white' SET Col_=7
IF %2'==white' SET ColAttr=0
IF %2'==+black' SET Col_=0
IF %2'==+black' SET ColAttr=1
IF %2'==+blue' SET Col_=4
IF %2'==+blue' SET ColAttr=1
IF %2'==+green' SET Col_=2
IF %2'==+green' SET ColAttr=1
IF %2'==+cyan' SET Col_=6
IF %2'==+cyan' SET ColAttr=1
IF %2'==+red' SET Col_=1
IF %2'==+red' SET ColAttr=1
IF %2'==+magenta' SET Col_=5
IF %2'==+magenta' SET ColAttr=1
IF %2'==+brown' SET Col_=3
IF %2'==+brown' SET ColAttr=1
IF %2'==+white' SET Col_=7
IF %2'==+white' SET ColAttr=1
GOTO Ende
:: ===================================================================

:Ende
::  -= E N D - of - Batch =- -------------------------
