@ECHO OFF
:: ===================================================
:: - Batch-Name: HangUp.BAT                          -
:: ===================================================
:: -         Batch by Uwe Morgener - 05.2003         -
:: -      fuer Crosspoint (XP2/OpenXP) und UKAW      -
:: ---------------------------------------------------
:: - Zweck: Verbindung abbauen und den User in-      -
:: - ====== formieren, wenn beim Nachrichten-Versand -
:: - Fehler aufgetreten ist.                         -
:: - (Dadurch kann die folgende XP-Meldung /immer/   -
:: - ignoriert werden: "Es konnten nicht alle Nach-  -
:: - richten versendet werden")                      -
:: - ----------------------------------------------- -
:: -       (gehrt zum Paket: 3P-Batch v1.20)        -
:: ---------------------------------------------------
::
:: aktives Modul (wird ggf. fuer Fehlermeldungen benoetigt)
:: (Sting muss 7 Zeichen lang sein - Fuellzeichen ".")
SET $Mod$=Hangup.
::
:: temporres Verzeichnis (RAM-Laufwerk) gesetzt?
IF NOT %RAM%'==' GOTO RAMok
:: %RAM% nicht definiert - daher auf Default setzen
IF NOT %TMP%'==' SET RAM=%TMP%
IF NOT %TEMP%'==' SET RAM=%TEMP%
:: Default leider auch nicht gesetzt
IF %RAM%'==' GOTO Ende

:RAMok
:: hat WDial /keine/ Verbindung hergestellt
IF NOT EXIST %RAM%\isDial.tmp GOTO noHangup

:: Verbindung abbauen (in allen anderen Fllen)
IF NOT EXIST %RAM%\UKAwDial.tmp IF NOT %1'==' WDial.exe %1 %2
:: Verbindung abbauen (bei Dial-Men-Auswahl "Rechner ist bereits online")
IF EXIST %RAM%\UKAwDial.tmp IF NOT %3'==' WDial.exe %3 %2
:: Verbindung abbauen: Ergebnis (Errorlevel) merken
FOR %%L IN (0 1 2) DO IF Errorlevel==%%L SET WDial_EL=%%L
:noHangup
:: Semaphor wieder lschen, falls vorhanden
IF EXIST %RAM%\UKAwDial.tmp DEL %RAM%\UKAwDial.tmp
IF EXIST %RAM%\isDial.tmp DEL %RAM%\isDial.tmp
GOTO Start

:: =====================================================================
:: "HighLevel-Fehlertexte" ---------------------------------------------

:Err3Pa ------ Fehler in 3Pa.exe aufgetreten
:: %UKAwPara%, %Para1% und ggf. %Para2% setzen (temp.bat wurde
:: von 3Pa.exe geschrieben, sofern darin ein Fehler auftrat)
CALL %RAM%\temp.bat
DEL %RAM%\temp.bat
GOTO ErrEnde2

:ErrEnde2
:: Fehlermeldung anzeigen und ins Log-File schreiben (3P-Batch.log)
CALL 3P-Sub.bat %UKAwPara% ErrShow
:: Hilfsvariablen lschen
FOR %%a IN (Para1 Para2) DO SET %%a=
GOTO Ende1

:NoESpace
CD %PPP%
:: Fehlermeldung anzeigen und ins Log-File schreiben (3P-Batch.log)
CALL 3P-Sub.bat NoESpace ErrShow /No
GOTO Ende1

:SndErr
:: alle gewnschten Nachrichten versandt? Hinweis- und Fehlermeldungen ausgeben
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==0010' CALL 3P-Sub.bat 1 SndShow 0 Mails
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==0001' CALL 3P-Sub.bat 1 SndShow 0 News
::
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==0011' CALL 3P-Sub.bat 2 SndShow 0
::
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==0110' CALL 3P-Sub.bat 3 SndShow 0 News Mails
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==1001' CALL 3P-Sub.bat 3 SndShow 0 Mails News
::
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==1101' CALL 3P-Sub.bat 4 SndShow 1 News
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==1010' CALL 3P-Sub.bat 4 SndShow 1 Mails
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==1110' CALL 3P-Sub.bat 4 SndShow 1 Mails
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==0101' CALL 3P-Sub.bat 4 SndShow 1 News
::
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==1111' CALL 3P-Sub.bat 5 SndShow 1
::
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==1011' CALL 3P-Sub.bat 6 SndShow 1 Mails News
IF %SndMail%%SndNews%%MSndErr%%NSndErr%'==0111' CALL 3P-Sub.bat 6 SndShow 1 News Mails
::
:: Fehlermeldung "Client hat Fehler protokolliert" anzeigen
IF %SndRvdEr%%MSndErr%%NSndErr%'==100' CALL 3P-Sub.bat 7 SndShow 1
GOTO Ende0
:: =====================================================================

:Start
:: Laufwerk setzen
CALL %RAM%\DriveTMP.bat
%Drive%

:: -= Arbeitsumgebung berprfen =-
:: wurde schon komplett in WDial.bat erledigt, daher bleibt hier nur noch

:: gengend Umgebungsspeicher vorhanden?
%PPP%\3P ESpace 512
IF Errorlevel==1 GOTO NoESpace

CD %PPP%
:: Namen der Pollbox-BFG-Datei holen und anschlieend die Hilfsdatei lschen
CALL %RAM%\BoxTMP.bat

:: "alle BFG-Namen holen (News/Mail)"
CALL %RAM%\UKAwPara.bat
:: Inhalt der Variable ist gleich /NoCall (Verbindung wurde /nicht/ hergestellt)
IF %UKAwPara%'==/NoCall' GOTO Ende0

:: Hilfsvariablen "initialisieren"
FOR %%S IN (MSndErr NSndErr) DO SET %%S=0

:: noch Mail zum Versand in den Spoolverzeichnissen?
:: "isMail" starten,
:: - folgende Daten ermitteln und per Steuerdatei an Hangup.bat
::   bergeben (CALL %RAM%\ParaTMP.bat setzt DOS-Umgebungsvariablen)
:: MailSnd: liegt noch Mail in den Spoolverzeichnissen? (1 = Ja, 0 = Nein)
3Pa.exe isMail %BFG_Name% -J:%JaeSa% -E:%ESetup%
:: innerhalb von 3Pa.exe Fehler aufgetreten?
IF ERRORLEVEL==1 GOTO Err3Pa
CALL %RAM%\ParaTMP.bat
DEL  %RAM%\ParaTMP.bat

:: noch News zum Versand in den Spoolverzeichnissen?
FOR %%B IN (%NewsName%) DO CALL 3P-Sub.bat %%B isNews

:: LogFile-Verzeichnis einlesen (und ScreenLines fr UUZ)
SET LogDir=
IF EXIST %XP%\XPoint.cfg CALL VAR GET LogDir ScreenLines FROM %XP%\XPoint.cfg

:: XP2
IF %XPv%'==0' SET _LogFile=%LogDir%XP-PPP.log

:: OpenXP
IF %XPv%'==1' CALL VAR GET Client-Path FROM %XP%\%BFG_Name%.BFG
IF %XPv%'==1' SET _LogFile=%XP%\%Client-Path%XPClient.log

:: wenn keine LogDatei gefunden wird, dann die nchsten Prfungen berspringen
IF NOT EXIST %_LogFile% GOTO Skip

:: prfen, ob der Client (E-Agent, E-Mail, E-News) einen Fehler protokolliert hat
SET SndRvdEr=1
3P XGREP -o "^! .+  XP.....#[n:1-9]" %_LogFile% >>%RAM%\3P-Mail$.100
IF ERRORLEVEL==1 SET SndRvdEr=0
:: sollte die 3P-Mail$.xxx leer sein (nichts gefunden), dann lschen
IF ERRORLEVEL==1 DEL %RAM%\3P-Mail$.100

:: prfen, ob der Client (E-Agent, E-Mail, E-News) Warnungen protokolliert hat
3P XGREP -o "^? .+  XP.....#[n:1-9]" %_LogFile% >>%RAM%\3P-Mail$.101
:: sollte die 3P-Mail$.xxx leer sein (nichts gefunden), dann lschen
IF ERRORLEVEL==1 DEL %RAM%\3P-Mail$.101

:Skip
:: Hilfsvariable sofort wieder lschen (bentigt viel Speicher)
SET _LogFile=
::
:: Anhand der Prfungen entscheiden, ob und wenn ja, welche Meldung anzuzeigen ist
:: trat ein Fehler beim Mail- und/oder Newsversand ein Fehler auf, 
:: dann Fehlermeldung ausgeben
IF NOT %MSndErr%%NSndErr%'==00' GOTO SndErr
:: verwendeter Client (E-Mail, E-News, E-Agent) meldete Fehler, der Mail
:: und Newsversand war jedoch erfolgreich, dann Fehlermeldung ausgeben
IF %SndRvdEr%%MSndErr%%NSndErr%'==100' GOTO SndErr

:Ende0
:: falls "News nur senden" gewhlt wurde, Dummy-Listen der bestellten Bretter
:: lschen und echte Liste der bestellten Bretter wieder "sichtbar machen",
:: auerdem gesicherte Request.id und neue Request.id zusammenfhren
CALL 3P-News.bat Hangup

:Ende1
:: Berichtmail im ZC-Format erstellen (der Aufbau ist unter DOS einfacher
:: zu erstellen, als das RFC-Format)
::
:: Liste der Fehlerklassen einlesen, zu denen eine Mail erstellt werden soll
:: und den Empfnger, an den diese gehen soll
CALL VAR GET ErrList, MailEMP FROM WBat.ini
::
:: falls in der WBat.ini kein Empfnger angegeben, die eigene eMail-Adresse
:: aus der BFG-Datei ($CONFIG) der Poll-Box ermitteln und als Empfnger ver-
:: wenden 
IF %MailEMP%'==' CALL VAR GET Pop3Envelope, Client-MailInEnvelope, Boxname FROM %XP%\%BFG_Name%.BFG
IF %MailEMP%'==' SET MailEMP=%Pop3Envelope%%Client-MailInEnvelope%
IF %MailEMP%'==' CALL VAR GET Username, Pointname, Domain FROM %XP%\%BFG_Name%.BFG
:: Empfnger aus den ermittelten Daten generieren
IF %MailEMP%'==' SET MailEMP=%Username%@%Pointname%%Domain%
::
:: Hilfsvariablen wieder lschen
FOR %%S IN (Username Pointname Domain) DO SET %%S=
FOR %%S IN (SndMail SndNews MSndErr NSndErr SndRvdEr) DO SET %%S=
FOR %%S IN (NewsName Drive JaeSa ESetup) DO SET %%S=
FOR %%S IN (UKAwPara Client MailPara NewsPara) DO SET %%S=

:: alle Fehler-Meldungen zu einer Liste (3P-Mail$.LOG) zusammenfhren
FOR %%D IN (000 %ErrList%) DO CALL 3P-Sub.bat %%D AddLog
:: Fehler-Mail aus 3P-Mail$.log generieren
:: Mail nur erstellen, wenn auch Fehlermeldungen geloggt
:: (3P-Mail$.LOG vorhanden und > 0 Byte)
IF NOT EXIST %RAM%\3P-Mail$.LOG GOTO NoMail
CALL VAR SET _Size=SIZE OF %RAM%\3P-Mail$.LOG
IF %_Size%'==0' DEL %RAM%\3P-Mail$.LOG
IF %_Size%'==0' GOTO NoMail
::
3P LOGECHO $h:$m - Fehler-Bericht > Betreff.tmp
:: berschrift der Berichtmail erstellen
3P QECHO "" CR LF "3P-Batch-Bericht zum" CR LF > %RAM%\3P-Title.LOG
3P LOGECHO Netzanruf vom $D.$M.$Y um $h:$m bei %Boxname%>> %RAM%\3P-Title.LOG
:: berschrift und Berichtmail zu einem Body zusammenfhren
COPY /B %RAM%\3P-Title.LOG+%RAM%\3P-Mail$.LOG %PPP%\Body.tmp >NUL
:: Hilfsdateien wieder lschen
DEL %RAM%\3P-Mail$.LOG
DEL %RAM%\3P-Title.LOG
:: Berichtmail generieren (ZC-Format)
CALL 3P-Sub.bat 3P-Batch Mail %MailEMP%
::
:: Berichtmail nach RFC konvertieren (UUZ.exe) & ins Spoolverzeichnis der Poll-
:: box legen, damit die Berichtmail von XP direkt nach dem Netcall-(Versuch) 
:: automatisch eingelesen wird (nur wenn RFC-Mails/-News im Spoolverzeichnis 
:: liegen, wird der Eingangspuffer (3PPuffer) auch eingelesen)

:: unbekannte XP-Variante, dann keine ZC-RFC-/RFC-ZC-Konvertierung durchfhren
IF %XPv%'==-1' GOTO noMail

:: Hilfsvariablen initialisieren
SET MSG_Size=

:: XP2: Spoolverzeichnis und ggf. UUZ-Aufrufe der Pollbox ermitteln
IF %XPv%'==0' CALL VAR GET PPP_UUZ_Spool PPP_UUZ_Out PPP_UUZ_In FROM %XP%\%BFG_Name%.BFG
:: OpenXP: Spoolverzeichnis der Pollbox ermitteln
IF %XPv%'==1' CALL VAR GET Client-Spool FROM %XP%\%BFG_Name%.BFG

::PPP_UUZ_Out_Teil_1 (ermittelten UUZ-Aufruf aufbereiten)
SET _UUZ=
SET Puffer=Autoexec\ErrorMSG.zer
SET Spool=%RAM%\
:: UUZ-Aufruf neu aufbauen (XP-Macros $PUFFER und $SPOOL ersetzen)
:: (wenn %PPP_UUZ_Out% leer ist, dann sind die folgenden beiden Zeilen wir-
:: kungslos - daher hier keine "IF NOT %PPP_UUZ_Out%'=='"-Abfrage erforderlich)
FOR %%Z IN (%PPP_UUZ_Out%) DO CALL 3P-Sub.bat %%Z SetUUZ
SET PPP_UUZ_Out=%_UUZ%
:: XP2: falls kein Eintrag in XP unter Edit/Boxen/<Box>/Edit/Clients/UUZ-out,
::      dann auf Default setzen
IF %XPv%'==0' IF %PPP_UUZ_Out%'==' SET PPP_UUZ_Out=UUZ.EXE -zu -SMTP -ppp %Puffer% %Spool%
:: OpenXP:  ... kennt kein "UUZ-out", daher immer auf Default setzen
IF %XPv%'==1' SET PPP_UUZ_Out=UUZ.EXE -zu -SMTP -client %Puffer% %Spool%

::PPP_UUZ_In_Teil_1 (ermittelten UUZ-Aufruf aufbereiten)
SET _UUZ=
SET Puffer=%RAM%\ErrorMSG.tmp
SET Spool=%RAM%\?????.out
:: UUZ-Aufruf neu aufbauen (XP-Macros $SCREENLINE, $SPOOL und $PUFFER ersetzen)
:: (wenn %PPP_UUZ_In% leer ist, dann sind die folgenden beiden Zeilen wirk
:: -ungslos - daher hier keine "IF NOT %PPP_UUZ_In%'=='"-Abfrage erforderlich)
FOR %%Z IN (%PPP_UUZ_In%) DO CALL 3P-Sub.bat %%Z SetUUZ
SET PPP_UUZ_In=%_UUZ%
:: XP2: falls kein Eintrag in XP unter Edit/Boxen/<Box>/Edit/Clients/UUZ-in,
::      dann auf Default setzen
IF %XPv%'==0' IF %PPP_UUZ_In%'==' SET PPP_UUZ_In=UUZ.EXE -uz %Spool% %Puffer% -b%Boxname%
:: OpenXP: ... kennt kein "UUZ-in", daher immer auf Default setzen
IF %XPv%'==1'  SET PPP_UUZ_In=UUZ.EXE -uz %Spool% %Puffer%

:: Hilfsvariablen hier sofort wieder lschen 
:: (vor allem %_UUZ% verbraucht viel Speicher)
FOR %%S IN (_UUZ _Add upper Puffer ScreenLines) DO SET %%S=
FOR %%S IN (_UUZa _UUZaU _UUZb _UUZbU) DO SET %%S=

:: UUZ aufrufen (eigentliche Konvertierung)
CD %XP1%
::
::PPP_UUZ_Out_Teil_2
:: 3P-Batch-Berichtmail (ZC) nach RFC konvertieren
%PPP_UUZ_Out% >NUL
:: Fehler aufgetreten?
IF NOT ERRORLEVEL==1 GOTO Next_1
:: ja, dann Fehlermeldung anzeigen und ins Log-File schreiben (3P-Batch.log)
:: Parameter fr die Fehlermeldung setzen
SET P1=UUZ-Out
:: UUZ-Hilfsvariable sofort lschen (verbraucht sehr viel Umgebungsspeicher)
SET PPP_UUZ_Out=
CD %PPP%
CALL 3P-Sub.bat ErrUUZ ErrShow /No
CD %XP1%
SET P1=
::
:Next_1
::PPP_UUZ_In_Teil_2
:: 3P-Batch-Berichtmail (RFC) wieder nach ZC konvertieren
:: Grund: siehe "PPP_UUZ_In_Teil_3"
IF EXIST %Spool% %PPP_UUZ_In% >NUL
:: Fehler aufgetreten?
IF NOT ERRORLEVEL==1 GOTO Next_2
:: ja, dann Fehlermeldung anzeigen und ins Log-File schreiben (3P-Batch.log)
:: Parameter fr die Fehlermeldung setzen
SET P1=UUZ-In
:: UUZ-Hilfsvariable sofort lschen (verbraucht sehr viel Umgebungsspeicher)
SET PPP_UUZ_In=
CD %PPP%
CALL 3P-Sub.bat ErrUUZ ErrShow /No
CD %XP1%
SET P1=
::
:Next_2
CD %PPP%

::PPP_UUZ_Out_Teil_3
:: Berichtmail in's richtige Spoolverzeichnis legen
::    Spoolverzeichnis von XP2
IF %XPv%'==0' SET Spool=%PPP_UUZ_Spool%
::    Spoolverzeichnis von OpenXP
IF %XPv%'==1' SET Spool=%Client-Spool%
IF EXIST %RAM%\?????.OUT COPY %RAM%\?????.OUT %Spool%P????.MSG >NUL

::PPP_UUZ_In_Teil_3
:: Gre von ErrorMSG.tmp ermitteln...
:: (dies entspricht der Gre des Eingangspuffer (3PPuffer),
:: der aus der RFC-Berichtmail resultiert)
IF EXIST %RAM%\ErrorMSG.tmp CALL VAR SET MSG_Size=SIZE OF %RAM%\ErrorMSG.tmp
:: ... und merken (fr 3P-In.bat)
ECHO SET MSG_Size=%MSG_Size%>> %RAM%\UKAwPara.bat

:: Definition der Hilfsvariablen wieder aufheben
FOR %%S IN (Spool Out In Client-Spool) DO SET PPP_UUZ_%%S=

:: "Hilfsdateien" wieder lschen (falls hier noch vorhanden)
IF EXIST %RAM%\?????.OUT DEL %RAM%\?????.OUT
IF EXIST %RAM%\ErrorMSG.tmp DEL %RAM%\ErrorMSG.tmp
IF EXIST %XP%\Autoexec\ErrorMSG.zer DEL %XP%\Autoexec\ErrorMSG.zer
IF EXIST %RAM%\temp.bat DEL %RAM%\temp.bat
::
:NoMail
IF EXIST %RAM%\3P-Mail$.LOG DEL %RAM%\3P-Mail$.LOG
:: Ergebnis von "Verbindung abbauen" wiederherstellen (Errorlevel setzen)
3P SEL %WDial_EL%
CD %XP1%
:: Definition der Hilfsvariablen wieder aufheben
FOR %%S IN (_Size MSG_Size WDial_EL BFG_Name) DO SET %%S=
FOR %%S IN (ErrList MailEMP Boxname XPv XP1 $Mod$) DO SET %%S=
:Ende
