@ECHO OFF
:: =====================================================
:: - Batch-Name: tClient.BAT                           -
:: =====================================================
:: -          Batch by Uwe Morgener - 05.2003          -
:: -       fuer Crosspoint (XP2/OpenXP) und UKAW       -
:: -----------------------------------------------------
:: - Zweck: Userschnittstelle um Programme zu starten, -
:: - ====== nachdem eine Verbindung zum Provider her-  -
:: -        gestellt wurde - z.B. einen Time-Clienten  -
:: -----------------------------------------------------
:: -        (gehrt zum Paket: 3P-Batch v1.20)         -
:: -----------------------------------------------------
::
:: Diese Batch wird gestartet, nachdem eine Verbindung
:: zum Provider hergestellt wurde, daher sollten Sie ueber
:: diese Batch nur Programme starten, die /keine/ Reaktion
:: (z.B. Beantworten von Fragen) durch den User erfordern...
::
:: Hier kann z.B. ein TimeClient gestartet werden, der
:: die PC-Uhr mit einem Timeserver synchronisiert (Datum
:: und Uhrzeit).
::
:: Diese Batch wird bei /jeder/ RFC/PPP- bzw. RFC/Client-
:: Box gestartet. Moechten Sie jedoch ein Programm nur bei
:: einer bestimmten Box starten, so werten Sie den Ueber-
:: gabeparameter %1 aus - dieser enthaelt den BFG-Namen
:: der Pollbox (/ohne/ Erweiterung).
::
:: Wichtig: Startverzeichnis ist immer Ihr XP-Verzeichnis
::
:: -=[ userspezifische Eintrge: Beginn ]=- -----------------------------------
::      (hier knnten Ihre Batchbefehle stehen.)
::      (Batches immer mit CALL <Batch> starten!)

:: -=[ userspezifische Eintrge: Ende ]=- -------------------------------------
::
:: SpoolBAK starten, wenn installiert
:: sicherheitshalber wieder auf XP-Laufwerk und -Verzeichnis zurcksetzen
%Drive%
CD %XP1%
:: Datum des Netcallstarts merken
:: (Vorbereitung fr: eingehende RFC-Nachrichten sichern)
IF EXIST %SPB%\SpoolBAK.bat CALL %SPB%\SpoolBAK.bat Init
::
:: Hinweis: Rckstellung von Laufwerk und Verzeichnis am Ende dieser Batch auf
:: das XP-Verzeichnis ist nicht notwendig - erledigt E-Agent.bat.
